libname rep "C:\Users\EDUGUET\FacCours\Cours_2014_2015\M2\Survie\r";


data tab; set rep.base_duree;
run;

proc iml;
use tab; read all var {censure}   into ci; /* censure */
         read all var {duree_emp} into yi;
n=nrow(yi);
di=J(n,1,1)-ci; /* donne complte */
nd=sum(di);
/* valeur initiale */
h0=nd/sum(yi);
lyi=log(yi); /* calcul une seule fois */
/* fonction Gamma tronque = Incomplete Gamma Function */
start igf(beta,x);/* fonction igf de paramtres beta et x */
f=probchi(2#x,2#beta);
do i=1 to nrow(f);  f[i]=min(1-1e-6,f[i]); end;
return (f);
finish;
start lv(theta) global(yi,di,nd,lyi); 
beta=exp(theta);
lfi=(beta-1)#lyi-lgamma(beta);
lsi=log(1-igf(beta,yi));
lv=sum(di#lfi+(1-di)#lsi);
return (lv);
finish;
print "Valeur initiale =" h0;
theta0=log(h0); lv0=lv(theta0);
print "Log-vraisemblance au point initial =" lv0;
opt=J(11,1,0); opt[1]=1; opt[2]=5;
call nlpnra(rc,thetamax,"lv",theta0,opt);
print "Code de rsultat =" rc;
call nlpfdd(Lmax,Smax,Hmax,"lv",thetamax);
elas=thetamax#Smax/Lmax;
print "Elasticit de la log-vraisemblance au paramtre =" elas,
"Gradient =" Smax,
"Hessien =" Hmax;
beta=exp(thetamax);
vtheta=-1/Hmax;
vbeta=beta##2#vtheta; sbeta=sqrt(vbeta); tbeta=abs(beta)/sbeta;
print "Beta =" beta, "Ecart type as. =" sbeta, "Student as. =" tbeta;
me=0.5#cinv(0.5,2#beta);
print "Mediane =" me;
do t=0 to 40 by 0.1;
ct=igf(beta,t); st=1-ct; ft=t##(beta-1)#exp(-t)/gamma(beta); ht=ft/st;
res=res//(t||ht||st||ct||ft);
end;
print res;
create tabres from res[colname=("t"||"ht"||"st"||"ct"||"ft")]; append from res;
quit;

proc print data=tabres;
run;
symbol1 c=black i=join v=none; symbol2 c=blue i=join v=none;
proc gplot data=tabres; plot (ht ft)*t/overlay grid haxis=0 to 40 by 5 ;
run;

proc gplot data=tabres; plot (ct st)*t/overlay grid haxis=0 to 20 by 5 vaxis=0 to 1 by 0.1;run;

proc export data=tabres outfile="C:\Users\EDUGUET\FacCours\tabres2.CSV"
dbms=DLM replace ;
delimiter=";";

run;
