libname rep "C:\Users\EDUGUET\FacCours\Cours_2014_2015\M2\Survie\r";


data tab; set rep.base_handi;
run;

proc iml;
use tab; read all var {d_hand}     into di; /* censure */
         read all var {duree_hand} into yi;
n=nrow(yi); nd=sum(di); 
h0=nd/sum(yi); 
pi=0.9;
start lv(theta) global(yi,di,nd,pi); /* paramtre de balayage */ 
h=exp(theta);
lfi=theta+log(1-pi)-h#yi; /* theta=log(h) */
lsi=log(pi+(1-pi)#exp(-h#yi));
lv=sum(di#lfi+(1-di)#lsi);
return (lv);
finish;
print "Valeur initiale =" h0;
theta0=log(h0); lv0=lv(theta0);
print "Log-vraisemblance au point initial =" lv0;
opt=J(11,1,0); opt[1]=1; opt[2]=0;
do pi=0.01 to 0.99 by 0.01;
call nlpnra(rc,theta,"lv",theta0,opt);
h=exp(theta);
res=res//(pi||h||lv(theta));
theta0=theta;
end;
rang=rank(res[,3]);
/*res2=rang||res;
print res2 ;*/
tri=res;/* pour affecter une matrice de mme taille */
tri[rank(res[,3]),]=res;
/*print tri;*/
res=tri[nrow(tri),]; print res;
pi=res[1];h=res[2];
do t=0 to 30;
st=pi+(1-pi)#exp(-h#t);
ct=1-st;
ft=h#(1-pi)#exp(-h#t);
ht=ft/st;
fonc=fonc//(t||st||ct||ft||ht);
end;
create tabres from res[colname=("pi"||"h"||"lv")]; append from res;
create fonc from fonc[colname=("t"||"st"||"ct"||"ft"||"ht")]; 
append from fonc;
quit;
run;

proc print data=fonc; run;
symbol1 c=black i=join v=none;
symbol2 c=blue i=join v=none;
proc gplot data=fonc; plot (ft ht)*t/overlay;
run;
proc gplot data=fonc; plot (ct st)*t/overlay grid;
run;

proc sort data=tabres; by descending lv;
proc print;
run;

run;
