
/* estimation des paramtres du modle  hasard constant par intervalle */
libname dur "C:\Users\EDUGUET\FacCours\Cours_2015_2016\M2_M";


options linesize=80;

data duree; set dur.base_duree;
data handi; set dur.base_handi;
run;

/* Kaplan - Meier */
proc lifetest NOPRINT data=duree method=km outsurv=skm;
time duree_emp*censure(1);
run;

data skm; set skm; by duree_emp;
if first.duree_emp;
label survival="S(t)" sdf_lcl="S(t)" sdf_ucl="S(t)";
run;

options reset=symbol ;
symbol1 i=stepJ c=black;
symbol2 i=stepJ c=blue;
symbol3 i=stepJ c=blue;
/*symbol1 i=join c=black;
symbol2 i=join c=blue;
symbol3 i=join c=blue;*/

proc gplot data=skm;
plot survival*duree_emp/haxis=0 to 52 by 1;
run;
proc gplot data=skm;
plot (survival sdf_lcl sdf_ucl)*duree_emp/overlay haxis=0 to 52 by 1;
run;

/* handicap */
/**/proc lifetest NOPRINT data=HANDI method=km outsurv=skm;
/**/time duree_hand*d_hand(0);
run;

/**/data skm; set skm; by duree_hand;
/**/if first.duree_hand;
label survival="S(t)" sdf_lcl="S(t)" sdf_ucl="S(t)";
run;

options reset=symbol ;
symbol1 i=stepJ c=black;
symbol2 i=stepJ c=blue;
symbol3 i=stepJ c=blue;
/*symbol1 i=join c=black;
symbol2 i=join c=blue;
symbol3 i=join c=blue;*/

proc gplot data=skm;
/**/plot survival*duree_hand/haxis=0 to 60 by 1 vaxis=0 to 1 by 0.1;
run;
proc gplot data=skm;
/**/plot (survival sdf_lcl sdf_ucl)*duree_hand/overlay haxis=0 to 60 by 1
vaxis=0 to 1 by 0.1;
run;

/* emploi */
proc lifetest NOPRINT data=duree method=km outsurv=skm;
time duree_emp*censure(1);
strata gen_h;
run;

data skm; set skm;
groupe=compress(gen_h||"+"||duree_emp);
proc sort; by groupe;
run;

data skm; set skm; by groupe; if first.groupe;
label survival="S(t)";
proc sort; by gen_h duree_emp;
run;

proc gplot data=skm;
/**/plot survival*duree_emp=gen_h/haxis=0 to 54 by 1 vaxis=0 to 1 by 0.1;
run;

/* par diplme */
data duree; set duree;
dip=dip_pri+2*dip_sec+3*dip_sup;
proc freq; tables dip;
run;

proc lifetest NOPRINT data=duree method=km outsurv=skm;
time duree_emp*censure(1);
strata dip;
run;

data skm; set skm;
/**/groupe=compress(dip||"+"||duree_emp);
proc sort; by groupe;
run;

data skm; set skm; by groupe; if first.groupe;
label survival="S(t)";
/**/proc sort; by dip duree_emp;
run;


symbol1 i=join v=none c=black;
symbol2 i=join v=none c=blue;
symbol3 i=join v=none c=green;

proc gplot data=skm;
/**/plot survival*duree_emp=dip/haxis=0 to 54 by 1 vaxis=0 to 1 by 0.1;
run;
