libname dur "C:\Users\EDUGUET\FacOuvrages\OuvrageDuree\data";
options linesize=80;

data duree; set dur.base_duree;
presence=1-censure;
c_nais1=(anaisenq<=1948);
c_nais2=(1948<anaisenq<=1958);
c_nais3=(1958<anaisenq<=1968);
c_nais4=(1968<anaisenq<=1978);
c_nais5=(1978<anaisenq<=1988);
parents=(fpermer=1);
lnais=log(anaisenq);
run;
/* paramtres du programme */
%let tab=duree; /* nom du tableau SAS contenant les donnes */
/* centrage des variables */
proc standard data=duree out=_tab mean=0; 
var dip_sec dip_sup gen_f lnais; run;

proc lifereg data=_tab;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais/
distribution=exponential;
run;


proc lifereg data=_tab;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais/
distribution=weibull;
run;


proc lifereg data=_tab OUTEST=param;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais/
distribution=weibull;
output out=sortie XBETA=xb;
run;
data _null_; set param;
call symput("sigma",_scale_);
run;
%put &sigma;
run;

data prev; set sortie; /* htrognit des hazards aprs 1 an */
hi1=exp(xb*&sigma)*(1/&sigma)*1**(1/&sigma-1);/* t=1 */
run;
proc means; var hi1;
run;
pattern1 c=blue v=L1;
proc gchart data=prev;
vbar hi1/midpoints=5 to 20 by 0.1;
run;

data prev; set sortie; /* htrognit des hazards aprs 1 an */
hi20=exp(xb*&sigma)*(1/&sigma)*20**(1/&sigma-1);/* t=1 */
run;
proc means; var hi1;
run;
pattern1 c=blue v=L1;
proc gchart data=prev;
vbar hi20/midpoints=5 to 20 by 0.1;
run;

/* log normal */

proc lifereg data=_tab OUTEST=param;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais /
distribution=LNORMAL;
output out=sortie XBETA=xb;
run;
data _null_; set param;
call symput("sigma",_scale_);
call symput("c",intercept);
run;
%put &sigma, &c;
run;

data ht; 
do t=0.1 to 30 by 0.1;
ht=1/(&sigma*t)*
pdf("normal",log(t)/&sigma-&c)/(1-cdf("normal",log(t)/&sigma-&c));
output;
end;
run;

symbol1 c=blue i=join v=none;
proc gplot data=ht;
plot ht*t;
run;


/* log logistique */

proc lifereg data=_tab OUTEST=param;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais /
distribution=LLOGISTIC;
output out=sortie XBETA=xb;
run;
data _null_; set param;
call symput("sigma",_scale_);
call symput("c",intercept);
run;
%put &sigma, &c;
run;


data ht; 
sigma=&sigma;
do t=0.1 to 30 by 0.1;
ht=1/(sigma*t)*
pdf("logistic",log(t)/sigma-&c)/
(1-cdf("logistic",log(t)/sigma-&c));
output;
end;
run;

symbol1 c=blue i=join v=none;
proc gplot data=ht;
plot ht*t;
run;

proc lifereg data=_tab OUTEST=param;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais /
distribution=GAMMA;
output out=sortie XBETA=xb;
run;
