libname dur "C:\Users\EDUGUET\FacOuvrages\OuvrageDuree\data";
options linesize=80;

data duree; set dur.base_duree;
presence=1-censure;
c_nais1=(anaisenq<=1948);
c_nais2=(1948<anaisenq<=1958);
c_nais3=(1958<anaisenq<=1968);
c_nais4=(1968<anaisenq<=1978);
c_nais5=(1978<anaisenq<=1988);
parents=(fpermer=1);
lnais=log(anaisenq);
run;
/* paramtres du programme */
%let tab=duree; /* nom du tableau SAS contenant les donnes */
/* centrage des variables */
proc standard data=duree out=_tab mean=0; 
var dip_sec dip_sup gen_f lnais; run;

data _tab; set _tab; lnais2=lnais**2;

proc phreg data=_tab;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais lnais2;
run;


proc freq ; tables duree_emp;
run;

proc phreg data=_tab;
model duree_emp*presence(0)=dip_sec dip_sup gen_f lnais lnais2;
baseline out=sortie  survival=s cumhaz=ch;
run;

symbol1 c=blue v=none i=join;
proc gplot data=sortie;
plot (s ch)*duree_emp;
run;

proc sort data=sortie; by duree_emp;
data hasard; set sortie; 
h=dif(ch);
if duree_emp=1 then h=ch;
if duree_emp<=45;
run;

symbol1 c=blue v=none i=stepJ;

proc gplot data=hasard;
plot h*duree_emp;
run;
